=== debian/changelog ===
wiredpanda (3.0.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 15 Aug 2021 22:44:03 +0100

wiredpanda (3.0.1-1) experimental; urgency=medium

  * New upstream version 3.0.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 31 Jul 2021 23:05:45 +0100

wiredpanda (3.0.0-1) experimental; urgency=medium

  * Initial release (Closes: #985939)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 28 Mar 2021 00:31:06 +0000
