=== debian/control ===
Source: wiredpanda
Section: electronics
Priority: optional
Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
Build-Depends: debhelper-compat (= 13), qtbase5-dev, qt5-qmake,
               qtbase5-dev-tools, libqt5charts5-dev, qtmultimedia5-dev
Standards-Version: 4.5.1
Homepage: https://github.com/GIBIS-UNIFESP/wiRedPanda
Vcs-Browser: https://salsa.debian.org/sudip/wiredpanda
Vcs-Git: https://salsa.debian.org/sudip/wiredpanda.git
Rules-Requires-Root: no

Package: wiredpanda
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: logic circuits simulator
 WiRed Panda is designed to help students to learn about logic circuits
 and simulate them in an easy and friendly way.
 .
 The main features of the software are:
    Real time logic simulation;
    User-friendly interface;
    It's intuitive and easy to use;
    Export your work as an image or a PDF.
