## wiredpanda 4.1.10

=== debian/changelog ===
wiredpanda (4.1.10-1) unstable; urgency=medium

  * New upstream version 4.1.10
    -  Refresh patch.
    - Update copyright.
    - Modify install and tests for Debian.
    - Install missing files.
    - Modify build dependency.
  * Update Standards-Version to 4.6.1.0

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 29 Oct 2022 00:29:03 +0100
