=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: optional
 Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), qtbase5-dev, qt5-qmake,
-               qtbase5-dev-tools, libqt5charts5-dev, qtmultimedia5-dev
-Standards-Version: 4.5.1
+               qtbase5-dev-tools, libqt5charts5-dev, qtmultimedia5-dev,
+               libqt5svg5-dev, xvfb, xauth
+Standards-Version: 4.6.1.0
 Homepage: https://github.com/GIBIS-UNIFESP/wiRedPanda
 Vcs-Browser: https://salsa.debian.org/sudip/wiredpanda
 Vcs-Git: https://salsa.debian.org/sudip/wiredpanda.git
