## wiredpanda 4.1.12

=== debian/changelog ===
wiredpanda (4.1.12-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:31:43 +1100

wiredpanda (4.1.12-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 07:30:24 +0000

wiredpanda (4.1.12-1) unstable; urgency=medium

  * New upstream version 4.1.12
    - Update copyright.
  * Update Standards Version to 4.6.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 05 Jul 2023 20:54:59 +0100
