=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: wiredpanda
 Section: electronics
 Priority: optional
-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), qtbase5-dev, qt5-qmake,
                qtbase5-dev-tools, libqt5charts5-dev, qtmultimedia5-dev,
                libqt5svg5-dev, xvfb, xauth
-Standards-Version: 4.6.1.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/GIBIS-UNIFESP/wiRedPanda
 Vcs-Browser: https://salsa.debian.org/sudip/wiredpanda
 Vcs-Git: https://salsa.debian.org/sudip/wiredpanda.git
