=== debian/changelog ===
wiredpanda (4.2.1-1) unstable; urgency=medium

  * New upstream version 4.2.1
    - Refresh patch.
    - Update copyright.
  * d/control: Update Standards-Version to 4.7.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 04 Apr 2025 23:13:14 +0100
