=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=qmake

override_dh_auto_install:
	dh_auto_install
	rm -rf debian/wiredpanda/usr/tests

override_dh_auto_test:
	export XDG_RUNTIME_DIR=/tmp/runtime-trace
	xvfb-run -a dh_auto_test
