=== debian/changelog ===
wiredpanda (4.2.6-1) unstable; urgency=medium

  * New upstream version 4.2.6

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 10 Aug 2025 12:55:38 +0100
