=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%wiredpanda-$1.tar.gz%" \
   https://github.com/GIBIS-UNIFESP/wiRedPanda/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
