=== debian/changelog ===
wiredpanda (4.3.0-1) unstable; urgency=medium

  * New upstream version 4.3.0
    - Update builds to use cmake.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 12 Dec 2025 13:53:08 +0000
