=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: electronics
 Priority: optional
 Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
-Build-Depends: debhelper-compat (= 13), qtbase5-dev, qt5-qmake,
+Build-Depends: debhelper-compat (= 13), qtbase5-dev,
                qtbase5-dev-tools, libqt5charts5-dev, qtmultimedia5-dev,
-               libqt5svg5-dev, xvfb, xauth
+               libqt5svg5-dev, xvfb, xauth, cmake
 Standards-Version: 4.7.2
 Homepage: https://github.com/GIBIS-UNIFESP/wiRedPanda
 Vcs-Browser: https://salsa.debian.org/sudip/wiredpanda
