=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --builddirectory=builddir

override_dh_auto_test:
	export XDG_RUNTIME_DIR=/tmp/runtime-trace
	xvfb-run -a dh_auto_test
